import type { BaseContract, BigNumber, BytesLike, CallOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../../common";
export interface AaveFarmInterface extends utils.Interface {
    functions: {
        "getCollateralRatio()": FunctionFragment;
        "lendFarmRouter()": FunctionFragment;
        "loanHealth()": FunctionFragment;
        "safeCollateralRatio()": FunctionFragment;
        "short()": FunctionFragment;
        "underlying()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "getCollateralRatio" | "lendFarmRouter" | "loanHealth" | "safeCollateralRatio" | "short" | "underlying"): FunctionFragment;
    encodeFunctionData(functionFragment: "getCollateralRatio", values?: undefined): string;
    encodeFunctionData(functionFragment: "lendFarmRouter", values?: undefined): string;
    encodeFunctionData(functionFragment: "loanHealth", values?: undefined): string;
    encodeFunctionData(functionFragment: "safeCollateralRatio", values?: undefined): string;
    encodeFunctionData(functionFragment: "short", values?: undefined): string;
    encodeFunctionData(functionFragment: "underlying", values?: undefined): string;
    decodeFunctionResult(functionFragment: "getCollateralRatio", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "lendFarmRouter", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "loanHealth", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "safeCollateralRatio", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "short", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlying", data: BytesLike): Result;
    events: {
        "HarvestedToken(address,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "HarvestedToken"): EventFragment;
}
export interface HarvestedTokenEventObject {
    token: string;
    amount: BigNumber;
}
export type HarvestedTokenEvent = TypedEvent<[
    string,
    BigNumber
], HarvestedTokenEventObject>;
export type HarvestedTokenEventFilter = TypedEventFilter<HarvestedTokenEvent>;
export interface AaveFarm extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: AaveFarmInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        getCollateralRatio(overrides?: CallOverrides): Promise<[BigNumber]>;
        lendFarmRouter(overrides?: CallOverrides): Promise<[string]>;
        loanHealth(overrides?: CallOverrides): Promise<[BigNumber]>;
        safeCollateralRatio(overrides?: CallOverrides): Promise<[BigNumber]>;
        short(overrides?: CallOverrides): Promise<[string]>;
        underlying(overrides?: CallOverrides): Promise<[string]>;
    };
    getCollateralRatio(overrides?: CallOverrides): Promise<BigNumber>;
    lendFarmRouter(overrides?: CallOverrides): Promise<string>;
    loanHealth(overrides?: CallOverrides): Promise<BigNumber>;
    safeCollateralRatio(overrides?: CallOverrides): Promise<BigNumber>;
    short(overrides?: CallOverrides): Promise<string>;
    underlying(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        getCollateralRatio(overrides?: CallOverrides): Promise<BigNumber>;
        lendFarmRouter(overrides?: CallOverrides): Promise<string>;
        loanHealth(overrides?: CallOverrides): Promise<BigNumber>;
        safeCollateralRatio(overrides?: CallOverrides): Promise<BigNumber>;
        short(overrides?: CallOverrides): Promise<string>;
        underlying(overrides?: CallOverrides): Promise<string>;
    };
    filters: {
        "HarvestedToken(address,uint256)"(token?: PromiseOrValue<string> | null, amount?: null): HarvestedTokenEventFilter;
        HarvestedToken(token?: PromiseOrValue<string> | null, amount?: null): HarvestedTokenEventFilter;
    };
    estimateGas: {
        getCollateralRatio(overrides?: CallOverrides): Promise<BigNumber>;
        lendFarmRouter(overrides?: CallOverrides): Promise<BigNumber>;
        loanHealth(overrides?: CallOverrides): Promise<BigNumber>;
        safeCollateralRatio(overrides?: CallOverrides): Promise<BigNumber>;
        short(overrides?: CallOverrides): Promise<BigNumber>;
        underlying(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        getCollateralRatio(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        lendFarmRouter(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        loanHealth(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        safeCollateralRatio(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        short(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
